# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define oname   appengine

Name:           google-appengine
Version:        1.5.1
Release:        2%{?dist}
Epoch:          0
Summary:        Google Application Engine

Group:          Development/Libraries/Java
License:        Apache Software License 2.0
URL:            http://code.google.com/appengine/
Source0:        google-appengine-1.5.1.tgz
# svn export -r 173 http://googleappengine.googlecode.com/svn/trunk/java google-appengine-1.5.1
# tar czf google-appengine-1.5.1.tgz google-appengine-1.5.1/
Source1:        http://repo1.maven.org/maven2/com/google/appengine/appengine/1.5.1/appengine-1.5.1.pom
Source2:        http://repo1.maven.org/maven2/com/google/appengine/appengine-api-1.0-sdk/1.5.1/appengine-api-1.0-sdk-1.5.1.pom
Source3:        http://repo1.maven.org/maven2/com/google/appengine/appengine-api-labs/1.5.1/appengine-api-labs-1.5.1.pom
Source4:        http://repo1.maven.org/maven2/com/google/appengine/appengine-api-stubs/1.5.1/appengine-api-stubs-1.5.1.pom
Source5:        http://repo1.maven.org/maven2/com/google/appengine/appengine-java-sdk/1.5.1/appengine-java-sdk-1.5.1.pom
Source6:        http://repo1.maven.org/maven2/com/google/appengine/appengine-jsr107cache/1.5.1/appengine-jsr107cache-1.5.1.pom
Source7:        http://repo1.maven.org/maven2/com/google/appengine/appengine-testing/1.5.1/appengine-testing-1.5.1.pom
Source8:        http://repo1.maven.org/maven2/com/google/appengine/appengine-tools-sdk/1.5.1/appengine-tools-sdk-1.5.1.pom
Source9:        http://repo1.maven.org/maven2/com/google/appengine/orm/datanucleus-appengine/1.0.8/datanucleus-appengine-1.0.8.pom


BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  easymock
BuildRequires:  jsr107cache
BuildRequires:  junit4
Requires:  java >= 0:1.6.0
Requires:  oss-parent
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

%description
Google App Engine enables you to build and host web apps on
the same systems that power Google applications. App Engine
offers fast development and deployment; simple
administration, with no need to worry about hardware,
patches or backups; and effortless scalability.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%prep
%setup -q 
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
ln -sf $(build-classpath junit4) src/generated/junit.jar
ln -sf $(build-classpath jsr107cache) src/generated/jsr107cache-1.1.jar
ln -sf $(build-classpath easymock) src/generated/easymock.jar

%build
ant 

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/agent
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/impl/agent
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/override
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/shared
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/jsp
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/testing
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/jsp
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/orm
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/user/orm
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/bin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/config
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/demos
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/docs
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/remoteapi
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/testing
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tools

cd build/dist/appengine-java-sdk-SNAPSHOT/

install -m 644 ABOUT $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 COPYING $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 README* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 RELEASE* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 755 bin/*.sh $RPM_BUILD_ROOT%{_datadir}/%{name}/bin
cp -pr config/* $RPM_BUILD_ROOT%{_datadir}/%{name}/config
cp -pr demos/* $RPM_BUILD_ROOT%{_datadir}/%{name}/demos
cp -pr docs/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr docs/remoteapi/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/remoteapi
cp -pr docs/testing/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/testing
cp -pr docs/tools/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tools
cp -p docs/*.dtd $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/docs
cp -p docs/*.xsd $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/docs

install -m 644 lib/agent/appengine-agentimpl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/agent/appengine-agentimpl-%{version}.jar
install -m 644 lib/agent/appengine-agent.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/agent/appengine-agent-%{version}.jar
install -m 644 lib/appengine-remote-api.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/appengine-remote-api-%{version}.jar
install -m 644 lib/appengine-tools-api.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/appengine-tools-api-%{version}.jar
install -m 644 lib/impl/agent/appengine-agentruntime.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/impl/agent/appengine-agentruntime-%{version}.jar
install -m 644 lib/impl/appengine-api.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/impl/appengine-api-%{version}.jar
install -m 644 lib/impl/appengine-api-labs.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/impl/appengine-api-labs-%{version}.jar
install -m 644 lib/impl/appengine-api-stubs.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/impl/appengine-api-stubs-%{version}.jar
install -m 644 lib/impl/appengine-local-runtime.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/impl/appengine-local-runtime-%{version}.jar
install -m 644 lib/override/appengine-dev-jdk-overrides.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/override/appengine-dev-jdk-overrides-%{version}.jar
install -m 644 lib/shared/appengine-local-runtime-shared.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/appengine-local-runtime-%{version}.jar
install -m 644 lib/shared/el-api.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/
install -m 644 lib/shared/jsp-api.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/
install -m 644 lib/shared/servlet-api.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/
install -m 644 lib/shared/jsp/repackaged-appengine-ant-1.7.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/jsp/
install -m 644 lib/shared/jsp/repackaged-appengine-ant-launcher-1.7.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/jsp/
install -m 644 lib/shared/jsp/repackaged-appengine-jasper-6.0.29.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/jsp/
install -m 644 lib/shared/jsp/repackaged-appengine-jasper-el-6.0.29.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/jsp/
install -m 644 lib/shared/jsp/repackaged-appengine-tomcat-juli-6.0.29.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/jsp/
install -m 644 lib/testing/appengine-testing.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/testing/appengine-testing-%{version}.jar
install -m 644 lib/tools/jsp/repackaged-appengine-jakarta-jstl-1.1.2.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/jsp/
install -m 644 lib/tools/jsp/repackaged-appengine-jakarta-standard-1.1.2.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/jsp/
install -m 644 lib/tools/jsp/repackaged-appengine-jasper-jdt-6.0.29.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/jsp/
install -m 644 lib/tools/orm/asm-3.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/orm/
install -m 644 lib/tools/orm/datanucleus-core-1.1.5.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/orm/
install -m 644 lib/tools/orm/datanucleus-enhancer-1.1.4.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/orm/
install -m 644 lib/tools/orm/datanucleus-jpa-1.1.5.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/orm/
install -m 644 lib/tools/orm/geronimo-jpa_3.0_spec-1.1.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/orm/
install -m 644 lib/tools/orm/geronimo-jta_1.1_spec-1.1.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/orm/
install -m 644 lib/tools/orm/jdo2-api-2.3-eb.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/orm/
install -m 644 lib/user/appengine-api-1.0-sdk-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/user/appengine-api-1.0-sdk-%{version}.jar
install -m 644 lib/user/appengine-api-labs-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/user/appengine-api-labs-%{version}.jar
install -m 644 lib/user/appengine-jsr107cache-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/user/appengine-jsr107cache-%{version}.jar
install -m 644 lib/user/jsr107cache-1.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/user/
install -m 644 lib/user/orm/datanucleus-appengine-1.0.9.final.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/user/orm/
install -m 644 lib/user/orm/datanucleus-core-1.1.5.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/user/orm/
install -m 644 lib/user/orm/datanucleus-jpa-1.1.5.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/user/orm/
install -m 644 lib/user/orm/geronimo-jpa_3.0_spec-1.1.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/user/orm/
install -m 644 lib/user/orm/geronimo-jta_1.1_spec-1.1.1.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/user/orm/
install -m 644 lib/user/orm/jdo2-api-2.3-eb.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/user/orm/

#src/orm/datanucleus-appengine-1.0.9.final-src.zip
#src/orm/datanucleus-core-1.1.5-src.zip
#src/orm/datanucleus-enhancer-1.1.4-src.zip
#src/orm/datanucleus-jpa-1.1.5-src.zip
#src/orm/jdo2-api-2.3-SNAPSHOT-src.zip

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/agent && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/impl && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/impl/agent && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/override && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/shared && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/shared/jsp && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/testing && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/tools && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/jsp && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/tools/orm && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/user && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/user/orm && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-appengine.pom
%add_to_maven_depmap com.google.appengine appengine %{version} JPP/%{name} appengine
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.user-appengine-api-1.0-sdk.pom
%add_to_maven_depmap com.google.appengine appengine-api-1.0-sdk %{version} JPP/%{name}/user appengine-api-1.0-sdk
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.impl-appengine-api-labs.pom
%add_to_maven_depmap com.google.appengine appengine-api-labs %{version} JPP/%{name}/impl appengine-api-labs
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.impl-appengine-api-stubs.pom
%add_to_maven_depmap com.google.appengine appengine-api-stubs %{version} JPP/%{name}/impl appengine-api-stubs
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-appengine-java-sdk.pom
%add_to_maven_depmap com.google.appengine appengine-java-sdk %{version} JPP/%{name} appengine-java-sdk
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.user-appengine-jsr107cache.pom
%add_to_maven_depmap com.google.appengine appengine-jsr107cache %{version} JPP/%{name}/user appengine-jsr107cache
install -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.testing-appengine-testing.pom
%add_to_maven_depmap com.google.appengine appengine-testing %{version} JPP/%{name}/testing appengine-testing

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root,-)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*
%{_datadir}/%{name}
%{_docdir}/%{name}-%{version}
%{_mavendepmapfragdir}/*
%{_datadir}/maven2/poms/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Fri Nov 11 2011 Ralph Apel <r.apel at r-apel.de> - 0:1.5.1-2
- Fix typo in agent jars version

* Fri Sep 30 2011 Ralph Apel <r.apel at r-apel.de> - 0:1.5.1-1
- First release

